# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jbossws-spi/%{version_full}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define version_maj 1
%define version_min 1
%define version_rev 2
%define version_tag GA
%define version_full %{version_maj}.%{version_min}.%{version_rev}.%{version_tag}

Name:           jbossws-spi
Version:        %{version_maj}.%{version_min}.%{version_rev}
Release:        3%{?dist}
Epoch:          0
Summary:        JBoss Web Services (SPI)
License:        LGPLv2+
Group:          Development/Java
URL:            http://labs.jboss.com/jbossws/
# svn -q export http://anonsvn.jboss.org/repos/jbossws/spi/tags/jbossws-spi-1.1.2.GA/ jbossws-spi-1.1.2 && tar cjf jbossws-spi-1.1.2.tar.bz2 jbossws-spi-1.1.2
Source0:        %{name}-%{version}.tar.bz2
Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-component-info.xml
Patch0:         jbossws-spi-pom-version.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       ejb_3_0_api
Requires:       servlet_2_5_api
Requires:       jaxb_2_1_api
Requires:       jaxws_2_1_api
Requires:       ant
Requires:       dom4j >= 0:1.6.1
Requires:       gnu-getopt
Requires:       jboss-common-core
Requires:       jboss-microcontainer2
Requires:       jbossxb2
BuildRequires:  ant
BuildRequires:  dom4j >= 0:1.6.1
BuildRequires:  gnu-getopt
BuildRequires:  jboss-common-core
BuildRequires:  jboss-microcontainer2
BuildRequires:  jboss-parent
BuildRequires:  jbossws-parent
BuildRequires:  jbossxb2
BuildRequires:  junit >= 0:3.8.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-surefire-report-maven-plugin
BuildRequires:  maven-release
# FIXME: (dwalluck): we need packages containing maven2 poms
#BuildRequires: ejb_3_0_api
BuildRequires:  geronimo-ejb-3.0-api
#BuildRequires: servlet25
BuildRequires:  geronimo-servlet-2.5-api
#BuildRequires: jaxb_2_1_api
BuildRequires:  glassfish-jaxb >= 0:2.1
#BuildRequires: jaxws_2_1_api
BuildRequires:  glassfish-jaxws >= 0:2.1
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBossWS SPI.

%package javadoc
Summary:         Javadoc for %{name}
Group:           Development/Documentation

%description javadoc
Javadoc for %{name}.

%if %with repolib
%package repolib
Summary:         Artifacts to be uploaded to a repository library
Group:           Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p0 -b .sav0
%{__mkdir_p} repository

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
%{__mkdir_p} ${MAVEN_REPO_LOCAL}
%{_bindir}/mvn-jpp \
    -Djboss.local.repository=$(pwd)/repository \
    -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
    -Dmaven.test.skip=true \
    -Dmaven.test.failure.ignore=false \
    -Dmaven2.jpp.depmap.file=%{SOURCE1} \
    install javadoc:javadoc

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p repository/jboss/jbossws-spi/%{version_full}/lib/jbossws-spi.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
%{__cp} -p repository/jboss/jbossws-spi/%{version_full}/lib/jbossws-spi-src.jar %{buildroot}%{_javadir}/%{name}-src-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}.jar; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{version}||g"`; done)

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr target/site/apidocs/*  %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# poms
%add_to_maven_depmap org.jboss.ws jbossws-spi %{version_full} JPP %{name}
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom

%if %with_repolib
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE2} %{buildroot}%{repodir}/component-info.xml
%{__sed} -i 's/@VERSION@/%{version_full}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE1} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/jbossws-spi.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}-src-%{version}.jar %{buildroot}%{repodirlib}/jbossws-spi-src.jar
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-src-%{version}.jar
%{_javadir}/%{name}-src.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Tue Sep 21 2010 David Walluck <dwalluck@redhat.com> 0:1.1.2-3
- remove Requires: jbossws-parent (pulls in maven2 at runtime)

* Wed Nov 25 2009 David Walluck <dwalluck@redhat.com> 0:1.1.2-2
- modify pom.xml to bring to AS5 levels

* Mon Sep 08 2009 David Walluck <dwalluck@redhat.com> 0:1.1.2-1
- 1.1.2

* Tue Sep 02 2008 David Walluck <dwalluck@redhat.com> 0:1.0.2-2
- fix jar location in repolib
- add sources and patches to repolib

* Fri Aug 29 2008 David Walluck <dwalluck@redhat.com> 0:1.0.2-1
- 1.0.2.GA
- fix component-info.xml

* Mon Jun 02 2008 David Walluck <dwalluck@redhat.com> 0:1.0.0-1.jpp5
- add epochs to dependencies
- quiet setup
- use setup macro to unpack sources
- fix License

* Wed Nov 14 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0-0jpp.ep1.7
- Quick fix to add 'version' and 'tag' attributes to the component-info.xml
  root element.

* Thu Nov 08 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0-0jpp.ep1.6
- Added -brew suffix for repolib

* Thu Nov 08 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0-0jpp.ep1.5
- First /actual/ building version

* Tue Nov 06 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0-0jpp.ep1.4
- Added missing defattr to files list

* Fri Nov 02 2007 Fernando Nasser <fnasser@redhat.com> 0:1.0.0-0jpp.ep1.3
- Add src ZIP to repolib

* Fri Nov 02 2007 Fernando Nasser <fnasser@redhat.com> 0:1.0.0-0jpp.ep1.2
- Build repolib

* Wed Oct 31 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0-0jpp.ep1.1
- Rebuild

* Wed Oct 31 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0.GA-0.1
- First release. Also, Halloween!
